Bug 1269001 - Review Request: tinycbor - Concise Binary Object Representation (CBOR) Library
Review Request: tinycbor - Concise Binary Object Representation (CBOR) Library
Status: ASSIGNED
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Tom Hughes
Fedora Extras Quality Assurance
:
Depends On:
Blocks: IoT
  Show dependency treegraph
 
Reported: 2015-10-05 18:07 EDT by Jared Smith
Modified: 2015-10-07 13:43 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
tom: fedora‑review?


Attachments (Terms of Use)

  None (edit)
Description Jared Smith 2015-10-05 18:07:18 EDT
Spec URL: https://jsmith.fedorapeople.org/Packaging/tinycbor/tinycbor.spec
SRPM URL: https://jsmith.fedorapeople.org/Packaging/tinycbor/tinycbor-0.2-1.fc23.src.rpm
Description: Concise Binary Object Representation (CBOR) Library
Fedora Account System Username: jsmith
Comment 1 Tom Hughes 2015-10-07 13:38:47 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[-]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Unknown or generated". 2 files have
     unknown license. Detailed output of licensecheck in
     /home/tom/1269001-tinycbor/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/pkgconfig
[!]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[!]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: Static libraries in -static or -devel subpackage, providing -devel if
     present.
     Note: Package has .a files: tinycbor-devel.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[!]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     tinycbor-devel
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
[x]: Rpmlint is run on debuginfo package(s).
     Note: There are rpmlint messages (see attachment).
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.


Rpmlint
-------
Checking: tinycbor-0.2-1.fc24.x86_64.rpm
          tinycbor-devel-0.2-1.fc24.x86_64.rpm
          tinycbor-0.2-1.fc24.src.rpm
tinycbor.x86_64: W: no-version-in-last-changelog
tinycbor.x86_64: W: no-manual-page-for-binary cbordump
tinycbor-devel.x86_64: W: no-version-in-last-changelog
tinycbor-devel.x86_64: W: no-documentation
tinycbor.src: W: no-version-in-last-changelog
tinycbor.src:47: E: hardcoded-library-path in /usr/lib/libtinycbor.a
tinycbor.src:48: E: hardcoded-library-path in /usr/lib/pkgconfig/tinycbor.pc
tinycbor.src:2: W: mixed-use-of-spaces-and-tabs (spaces: line 1, tab: line 2)
3 packages and 0 specfiles checked; 2 errors, 6 warnings.




Rpmlint (debuginfo)
-------------------
Checking: tinycbor-debuginfo-0.2-1.fc24.x86_64.rpm
tinycbor-debuginfo.x86_64: W: no-version-in-last-changelog
tinycbor-debuginfo.x86_64: E: debuginfo-without-sources
1 packages and 0 specfiles checked; 1 errors, 1 warnings.





Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
tinycbor-debuginfo.x86_64: W: no-version-in-last-changelog
tinycbor-debuginfo.x86_64: E: debuginfo-without-sources
tinycbor.x86_64: W: no-version-in-last-changelog
tinycbor.x86_64: W: no-manual-page-for-binary cbordump
tinycbor-devel.x86_64: W: no-version-in-last-changelog
tinycbor-devel.x86_64: W: no-documentation
3 packages and 0 specfiles checked; 1 errors, 5 warnings.



Diff spec file in url and in SRPM
---------------------------------
--- /home/tom/1269001-tinycbor/srpm/tinycbor.spec	2015-10-07 18:26:41.292908882 +0100
+++ /home/tom/1269001-tinycbor/srpm-unpacked/tinycbor.spec	2015-10-05 22:48:44.000000000 +0100
@@ -1,8 +1,8 @@
-Name:		tinycbor
+Name:           tinycbor
 Version:	0.2
-Release:	1%{?dist}
+Release:        1%{?dist}
 Summary:	Concise Binary Object Representation (CBOR) Library
 
-License:	MIT
+License:        MIT
 URL:		https://github.com/01org/tinycbor
 Source0:	https://github.com/01org/tinycbor/archive/v0.2.tar.gz
@@ -12,6 +12,6 @@
 Patch1:		tinycbor_DEFAULT_SOURCE.patch
 
-#BuildRequires:
-#Requires:
+#BuildRequires:	
+#Requires:       
 
 %description
@@ -45,7 +45,7 @@
 
 %files devel
-%{libdir}/libtinycbor.a
-%{libdir}/pkgconfig/tinycbor.pc
-%{includedir}/tinycbor
+/usr/lib/libtinycbor.a
+/usr/lib/pkgconfig/tinycbor.pc
+/usr/include/tinycbor
 
 %changelog


Requires
--------
tinycbor (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libm.so.6()(64bit)
    rtld(GNU_HASH)

tinycbor-devel (rpmlib, GLIBC filtered):



Provides
--------
tinycbor:
    tinycbor
    tinycbor(x86-64)

tinycbor-devel:
    tinycbor-devel
    tinycbor-devel(x86-64)
    tinycbor-static



Source checksums
----------------
https://github.com/01org/tinycbor/archive/v0.2.tar.gz :
  CHECKSUM(SHA256) this package     : 6a5add2a68faec34e9235cb3a8987fa9880bb106ad7473e1435e9742223b25df
  CHECKSUM(SHA256) upstream package : 6a5add2a68faec34e9235cb3a8987fa9880bb106ad7473e1435e9742223b25df


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -m compton-rawhide-x86_64 -b 1269001
Buildroot used: compton-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 2 Tom Hughes 2015-10-07 13:43:34 EDT
Quite a few things here:

[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/pkgconfig

Need to require pkgconfig, and in any case it should be lib64
for both this and the library on x86_64.

[!]: %build honors applicable compiler flags or justifies otherwise.

Need to get $RPM_OPT_FLAGS in there.

[!]: Package consistently uses macros (instead of hard-coded directory
     names).

Use %{_bindir}, %{_libdir} etc in file lists.

[!]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.

MIT license requires text so we will need to add it locally
until upstream do.

[!]: %check is present and all tests pass.

There are tests, any chance of running them?

[!]: Spec file according to URL is the same as in SRPM.

See fedora-review output.

Also no version number in changelog header.
Comment 3 Tom Hughes 2015-10-07 13:43:58 EDT
Also, per https://fedoraproject.org/wiki/Packaging:Guidelines#Packaging_Static_Libraries we should be trying to build it as a shared library if possible...

Note You need to log in before you can comment on or make changes to this bug.